uniform vec2 u_resolution;
uniform vec2 u_mouse;
uniform float u_time;
uniform sampler2D texture;

vec2 random2(vec2 p) {
    return fract(sin(vec2(dot(p,vec2(127.1,311.7)),dot(p,vec2(269.5,183.3))))*43758.5453);
}

void main() {
  vec2 st = gl_FragCoord.xy/u_resolution.xy;
  st.x *= u_resolution.x/u_resolution.y;
  vec3 color = vec3(0.0);

  st *= 3.0;

  vec2 i_st = floor(st);
  vec2 f_st = fract(st);

  float m_dist = 1.0;

  for(int y = -1; y <= 1; y++) {
    for(int x = -1; x <= 1; x++) {
      vec2 neighbor = vec2(float(x), float(y));

      vec2 point = random2(i_st + neighbor);
      point = 0.5 + 0.5*sin(u_time + 6.2831 * point);
      vec2 diff = neighbor + point - f_st;
      float dist = length(diff);
      m_dist = min(m_dist, dist);
    }
  }

  color += m_dist;
  color += 1.0 - step(0.02, m_dist);
  color += step(1.0, f_st.x) + step(1.0, f_st.y);

  vec4 pixel = texture2D(texture, gl_TexCoord[0].xy);

  gl_FragColor = gl_Color * vec4(color / 0.8, 1.0) * pixel;
}
